package com.caimei.mapper;

import com.caimei.model.po.CmBrandAuthFilePo;
import com.caimei.model.po.ShopInfoPo;
import com.caimei.model.po.UserPo;
import com.caimei.model.vo.ShopVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * Description
 *
 * @author : Aslee
 * @date : 2021/5/11
 */
@Mapper
public interface ShopMapper {

    List<ShopVo> getShopList(@Param("shopName") String shopName, @Param("shopType") Integer shopType, @Param("brandId") Integer brandId, @Param("mobile") String mobile, @Param("linkMan") String linkMan);

    void updateShopStatusByUserId(@Param("authUserId") Integer authUserId, @Param("status") Integer status);

    String getShopMobileByUserId(Integer authUserId);

    CmBrandAuthFilePo getStatementFile(CmBrandAuthFilePo searchFile);

    void insertStatementFile(CmBrandAuthFilePo cmBrandAuthFile);

    Integer getFileNumByMd5Hex(String md5Hex);

    void deleteStatementFile(Integer id);

    void insertShop(UserPo shop);

    void updateBrandAuthLogo(Integer brandId);

    void updateFileUserId(@Param("statementFileId") Integer statementFileId,@Param("authUserId") Integer authUserId);

    void insertShopInfo(ShopInfoPo shopInfo);

    void updateShopByUserId(UserPo shop);

    void updateShopInfoByUserId(ShopInfoPo shopInfo);

    ShopVo getShopByAuthUserId(Integer authUserId);
}
